## ktorrent 5.1.0

=== ktmagnetdownloader/CMakeLists.txt ===
set(magnetdownloadtest_SRCS magnetdownloader.cpp magnettest.cpp)
add_executable(ktmagnetdownloader ${magnetdownloadtest_SRCS})
target_link_libraries(ktmagnetdownloader ktcore Qt5::Widgets Qt5::Network)
install(TARGETS ktmagnetdownloader ${INSTALL_TARGETS_DEFAULT_ARGS})

=== libktcore/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config-ktcore.h.cmake ${CMAKE_BINARY_DIR}/config-ktcore.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(libktorrent_SRC 
	util/mmapfile.cpp
	util/itemselectionmodel.cpp
	util/stringcompletionmodel.cpp
	util/treefiltermodel.cpp
	
	interfaces/functions.cpp
	interfaces/plugin.cpp
	interfaces/guiinterface.cpp
	interfaces/coreinterface.cpp
	interfaces/prefpageinterface.cpp
	interfaces/activity.cpp
	interfaces/torrentactivityinterface.cpp
	
	torrent/queuemanager.cpp
	torrent/magnetmanager.cpp
	torrent/torrentfilemodel.cpp
	torrent/torrentfiletreemodel.cpp
	torrent/torrentfilelistmodel.cpp
	torrent/chunkbar.cpp 
	torrent/chunkbarrenderer.cpp
	torrent/jobtracker.cpp
	torrent/jobprogresswidget.cpp 
	torrent/basicjobprogresswidget.cpp 
	
	groups/group.cpp
	groups/torrentgroup.cpp
	groups/allgroup.cpp
	groups/ungroupedgroup.cpp
	groups/groupmanager.cpp
	groups/functiongroup.cpp
	
	dbus/dbus.cpp
	dbus/dbustorrent.cpp
	dbus/dbusgroup.cpp
	dbus/dbussettings.cpp
	dbus/dbustorrentfilestream.cpp
	
	gui/centralwidget.cpp
	gui/tabbarwidget.cpp
	gui/extender.cpp
	
	plugin/pluginmanager.cpp
	plugin/pluginactivity.cpp

	ktorrent.kcfg
)

set(libktorrent_UI torrent/basicjobprogresswidget.ui )

ki18n_wrap_ui(libktorrent_SRC ${libktorrent_UI})
kconfig_add_kcfg_files(libktorrent_SRC settings.kcfgc)
add_library(ktcore ${libktorrent_SRC})
generate_export_header(ktcore BASE_NAME ktcore)

target_link_libraries(ktcore PUBLIC
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::I18n
    KF5::KCMUtils
    KF5::Parts
    KF5::Service
    KF5::Solid
    KF5::Torrent
    KF5::XmlGui
)

target_include_directories(ktcore PUBLIC "$<BUILD_INTERFACE:${KTORRENT_SOURCE_DIR}/libktcore;${KTORRENT_BINARY_DIR}/libktcore;${KTORRENT_BINARY_DIR}>")

set_target_properties(ktcore PROPERTIES VERSION 16.0.0 SOVERSION 16 )
install(TARGETS ktcore  ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== plugins/CMakeLists.txt ===
MACRO (MACRO_KT_PLUGIN _option _name _dir)
option(${_option} "Whether to build the ${_name} plugin or not" true)
if (${_option})
  message(STATUS "Building ${_name} plugin (-D${_option}=false to disable)")
  add_subdirectory(${_dir})
else (${_option})
  message(STATUS "Not building ${_name} plugin (-D${_option}=true to enable)")
endif (${_option})
ENDMACRO (MACRO_KT_PLUGIN)

macro_kt_plugin(ENABLE_LOGVIEWER_PLUGIN logviewer logviewer)
macro_kt_plugin(ENABLE_INFOWIDGET_PLUGIN infowidget infowidget)
if (HAVE_KF5Completion)
    macro_kt_plugin(ENABLE_UPNP_PLUGIN upnp upnp)
endif()
if (HAVE_KF5WebKit)
  macro_kt_plugin(ENABLE_SEARCH_PLUGIN search search)
endif()
#macro_kt_plugin(ENABLE_WEBINTERFACE_PLUGIN webinterface webinterface)
macro_kt_plugin(ENABLE_SCANFOLDER_PLUGIN scanfolder scanfolder)
if(HAVE_QT5_Test)
  set(HAVE_QT5_Test2 1)
endif()
if (HAVE_KF5TextWidgets)
    macro_kt_plugin(ENABLE_IPFILTER_PLUGIN ipfilter ipfilter)
endif()
if (HAVE_KF5Plotting)
    macro_kt_plugin(ENABLE_STATS_PLUGIN stats stats)
endif()
macro_kt_plugin(ENABLE_BWSCHEDULER_PLUGIN bwscheduler bwscheduler)
if (HAVE_Taglib AND PHONON_FOUND_EXPERIMENTAL) #AND Qt5Multimedia_FOUND)
  macro_kt_plugin(ENABLE_MEDIAPLAYER_PLUGIN mediaplayer mediaplayer)
endif()
if (HAVE_KF5Archive AND HAVE_KF5ItemViews AND HAVE_KF5Kross)
  macro_kt_plugin(ENABLE_SCRIPTING_PLUGIN scripting scripting)
endif()
if (HAVE_KF5Syndication AND HAVE_KF5WebKit)
  macro_kt_plugin(ENABLE_SYNDICATION_PLUGIN syndication syndication)
endif()
macro_kt_plugin(ENABLE_DOWNLOADORDER_PLUGIN downloadorder downloadorder)
if (HAVE_LibKWorkspace)
  macro_kt_plugin(ENABLE_SHUTDOWN_PLUGIN shutdown shutdown)
endif()
if (HAVE_KF5DNSSD)
  macro_kt_plugin(ENABLE_ZEROCONF_PLUGIN zeroconf zeroconf)
endif()
macro_kt_plugin(ENABLE_MAGNETGENERATOR_PLUGIN magnetgenerator magnetgenerator)

=== ktorrent/icons/CMakeLists.txt ===
ecm_install_icons(ICONS
    16-actions-kt-stop-all.png
    16-actions-kt-stop.png
    16-actions-kt-upnp.png
    16-apps-ktorrent.png
    22-actions-kt-magnet.png
    22-actions-kt-pause.png
    22-actions-kt-remove.png
    22-actions-kt-set-max-download-speed.png
    22-actions-kt-set-max-upload-speed.png
    22-actions-kt-speed-limits.png
    22-actions-kt-start-all.png
    22-actions-kt-start.png
    22-actions-kt-stop-all.png
    22-actions-kt-stop.png
    22-apps-ktorrent.png
    32-actions-kt-info-widget.png
    32-actions-kt-magnet.png
    32-actions-kt-pause.png
    32-actions-kt-queue-manager.png
    32-actions-kt-remove.png
    32-actions-kt-set-max-download-speed.png
    32-actions-kt-set-max-upload-speed.png
    32-actions-kt-speed-limits.png
    32-actions-kt-start-all.png
    32-actions-kt-start.png
    32-actions-kt-stop-all.png
    32-actions-kt-stop.png
    32-actions-kt-upnp.png
    32-apps-ktorrent.png
    48-actions-kt-bandwidth-scheduler.png
    48-actions-kt-change-tracker.png
    48-actions-kt-check-data.png
    48-actions-kt-chunks.png
    48-actions-kt-info-widget.png
    48-actions-kt-magnet.png
    48-actions-kt-pause.png
    48-actions-kt-plugins.png
    48-actions-kt-queue-manager.png
    48-actions-kt-remove.png
    48-actions-kt-restore-defaults.png
    48-actions-kt-set-max-download-speed.png
    48-actions-kt-set-max-upload-speed.png
    48-actions-kt-show-hide.png
    48-actions-kt-show-statusbar.png
    48-actions-kt-speed-limits.png
    48-actions-kt-start-all.png
    48-actions-kt-start.png
    48-actions-kt-stop-all.png
    48-actions-kt-stop.png
    48-actions-kt-upnp.png
    48-apps-ktorrent.png
    64-actions-kt-magnet.png
    64-apps-ktorrent.png
    sc-actions-kt-magnet.svgz
    sc-actions-kt-set-max-download-speed.svgz
    sc-actions-kt-set-max-upload-speed.svgz
    sc-actions-kt-speed-limits.svgz
    DESTINATION ${ICON_INSTALL_DIR}
    THEME hicolor
)

=== plugins/bwscheduler/CMakeLists.txt ===
set(ktbwschedulerplugin_SRC 
	bwschedulerplugin.cpp 
	weekview.cpp 
	weekscene.cpp 
	schedule.cpp 
	scheduleeditor.cpp 
	schedulegraphicsitem.cpp 
	bwprefpage.cpp 
	guidanceline.cpp 
	edititemdlg.cpp 
	weekdaymodel.cpp
)

set(screensaver_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.ScreenSaver.xml)
qt5_add_dbus_interface(ktbwschedulerplugin_SRC ${screensaver_xml} screensaver_interface)

ki18n_wrap_ui(ktbwschedulerplugin_SRC edititemdlg.ui bwprefpage.ui)
kconfig_add_kcfg_files(ktbwschedulerplugin_SRC bwschedulerpluginsettings.kcfgc)
add_library(ktorrent_bwscheduler MODULE ${ktbwschedulerplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_bwscheduler ktorrent_bwscheduler.desktop)

target_link_libraries(
    ktorrent_bwscheduler
    ktcore
    KF5::Torrent
    KF5::CoreAddons
    KF5::I18n
    KF5::XmlGui
    KF5::WidgetsAddons
)
install(TARGETS ktorrent_bwscheduler  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_bwschedulerui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

=== plugins/ipfilter/CMakeLists.txt ===
set(ktipfilterplugin_SRC ipblocklist.cpp ipblockingprefpage.cpp convertthread.cpp convertdialog.cpp ipfilterplugin.cpp downloadandconvertjob.cpp)

ki18n_wrap_ui(ktipfilterplugin_SRC ipblockingprefpage.ui convertdialog.ui)
kconfig_add_kcfg_files(ktipfilterplugin_SRC ipfilterpluginsettings.kcfgc)
add_library(ktorrent_ipfilter MODULE ${ktipfilterplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_ipfilter ktorrent_ipfilter.desktop)

target_link_libraries(
    ktorrent_ipfilter
    ktcore
    KF5::Torrent
    KF5::Archive
    KF5::CoreAddons
    KF5::I18n
    KF5::KIOWidgets
    KF5::Notifications
    KF5::TextWidgets
    KF5::WidgetsAddons
)
install(TARGETS ktorrent_ipfilter DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )

find_package(Qt5Test ${QT5_REQUIRED_VERSION})
if (Qt5Test_DIR)
    add_subdirectory(tests)
endif()

=== plugins/scanfolder/CMakeLists.txt ===
set(ktscanfolderplugin_SRC 
	scanthread.cpp 
	torrentloadqueue.cpp 
	scanfolder.cpp 
	scanfolderplugin.cpp 
	scanfolderprefpage.cpp)

ki18n_wrap_ui(ktscanfolderplugin_SRC scanfolderprefpage.ui)
kconfig_add_kcfg_files(ktscanfolderplugin_SRC scanfolderpluginsettings.kcfgc)
add_library(ktorrent_scanfolder MODULE ${ktscanfolderplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_scanfolder ktorrent_scanfolder.desktop)

target_link_libraries(
    ktorrent_scanfolder
    ktcore
    KF5::Torrent
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::I18n
    KF5::KIOCore
)
install(TARGETS ktorrent_scanfolder  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )

=== plugins/webinterface/CMakeLists.txt ===
set(ktwebinterfaceplugin_SRC 
	httpresponseheader.cpp 
	httpclienthandler.cpp 
	httpserver.cpp
	webinterfaceprefwidget.cpp
	webinterfaceplugin.cpp
	webcontentgenerator.cpp
	globaldatagenerator.cpp
	torrentlistgenerator.cpp
	torrentfilesgenerator.cpp
	challengegenerator.cpp
	settingsgenerator.cpp
	loginhandler.cpp
	logouthandler.cpp
	actionhandler.cpp
	iconhandler.cpp
	torrentposthandler.cpp)

ki18n_wrap_ui(ktwebinterfaceplugin_SRC webinterfaceprefwidget.ui)
kconfig_add_kcfg_files(ktwebinterfaceplugin_SRC webinterfacepluginsettings.kcfgc)
add_library(ktwebinterfaceplugin MODULE ${ktwebinterfaceplugin_SRC})

target_link_libraries(
    ktwebinterfaceplugin
    ktcore
    ${LIBKTORRENT_LIBRARIES}
)
install(TARGETS ktwebinterfaceplugin  DESTINATION ${PLUGIN_INSTALL_DIR} )
install(FILES ktwebinterfaceplugin.desktop  DESTINATION  ${SERVICES_INSTALL_DIR} )
add_subdirectory(www)

=== plugins/zeroconf/CMakeLists.txt ===
set(ktzeroconfplugin_SRC zeroconfplugin.cpp torrentservice.cpp)

# ki18n_wrap_ui(ktzeroconfplugin_SRC zeroconfpref.ui searchbar.ui)
#kconfig_add_kcfg_files(ktzeroconfplugin_SRC zeroconfpluginsettings.kcfgc)
add_library(ktorrent_zeroconf MODULE ${ktzeroconfplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_zeroconf ktorrent_zeroconf.desktop)

target_link_libraries(ktorrent_zeroconf
    ktcore
    KF5::Torrent
    KF5::CoreAddons
    KF5::DNSSD
    KF5::I18n
)
install(TARGETS ktorrent_zeroconf  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )

=== plugins/webinterface/www/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(coldmilk)
add_subdirectory(default)
add_subdirectory(mobile)

=== debian/changelog ===
ktorrent (5.1.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Tue, 05 Sep 2017 21:06:30 +0200

ktorrent (5.1.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release: (Closes: #821180)
    - the plugin system of Frameworks does not use sycoca anymore
      (Closes: #504271)
    - fixes a download order bug in queue (Closes: #763902)
    - the ipfilter plugin updates correctly from compressed files
      (Closes: #767218) (LP: #1207589)
    - switches from Qt4 (using QtWebKit) to Frameworks (Closes: #784487)
    - the switch to KF5 makes the scripting plugin work again, as krosspython
      was already switched to KF5 (Closes: #832547)
    - the search line edit is reset when closing it (Closes: #859250)
  * Update the build dependencies following the port to Frameworks:
    - remove libqt4-dev, kdelibs5-dev, libphonon-dev, kdepimlibs5-dev, and
      libqtwebkit-dev
    - add extra-cmake-modules, qtbase5-dev, qtscript5-dev, libphonon4qt5-dev,
      libphonon4qt5experimental-dev, libkf5archive-dev, libkf5completion-dev,
      libkf5config-dev, libkf5configwidgets-dev, libkf5coreaddons-dev,
      libkf5crash-dev, libkf5dbusaddons-dev, libkf5dnssd-dev,
      libkf5doctools-dev, libkf5i18n-dev, libkf5iconthemes-dev, libkf5kio-dev,
      libkf5itemviews-dev, libkf5notifications-dev, libkf5notifyconfig-dev,
      libkf5kcmutils-dev, libkf5parts-dev, libkf5plotting-dev,
      libkf5service-dev, libkf5solid-dev, libkf5textwidgets-dev,
      libkf5widgetsaddons-dev, libkf5windowsystem-dev, libkf5xmlgui-dev,
      libkf5webkit-dev, kross-dev, and libkf5syndication-dev
  * Update the patches:
    - dont_link_with_kutils.patch: drop, obsolete
    - upstream_Properly-support-x-scheme-handler-magnet-mimetype-an.patch:
      drop, backported from upstream
    - upstream_webinterface-rename-major-minor-to-major_version-min.patch:
      drop, backported from upstream
  * Use the right dh addon:
    - switch from kde to kf5 dh addon
    - bump the pkg-kde-tools build dependency to >= 0.15.16
  * Bump the libktorrent-dev build dependency to >= 2.1.
  * Update install files.
  * Update Vcs-Browser field.
  * Switch Homepage away from the dead ktorrent.org. (Closes: #837216)
  * Call dh_install with --fail-missing, so nothing is accidentally left
    uninstalled.
  * Update lintian overrides.
  * Remove obsolete not-installed file.
  * Suggest geoip-database, even if libgeoip1 already recommends it.
    (Closes: #778813)
  * Update the flags for cmake:
    - drop -DCMAKE_USE_RELATIVE_PATHS=ON, obsolete since cmake 3.2
    - switch -DKDE4_BUILD_TESTS=false to -DBUILD_TESTING=OFF, which is what
      ECM provides
  * Remove the libx11-dev build dependency, no more needed.
  * Drop all the pre-Jessie replaces/breaks.
  * Bump the cmake build dependency to >= 2.8.12.
  * Bump Standards-Version to 4.1.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Fri, 01 Sep 2017 23:22:02 +0200

ktorrent (4.3.1-5) unstable; urgency=medium

  * Team upload.
  * Remove ktorrent-dbg in favour of the -dbgsym packages.
  * Bump Standards-Version to 3.9.8, no changes required.
  * Update watch file.

 -- Pino Toscano <pino@debian.org>  Tue, 07 Jun 2016 16:47:22 +0200

ktorrent (4.3.1-4) unstable; urgency=medium

  * Team upload.
  * Remove obsolete and unused installgen file.
  * Update Vcs-* fields.
  * Drop menu file and its pixmap, since ktorrent already provides a .desktop
    file.
  * Remove the README.Debian file, since all the information it contains are
    long obsolete.
  * Restore the krosspython suggest in ktorrent, removed in 4.3.1-3.
  * Backport upstream commit e22c887b55ec5e83db959c3b98d448947c886cc0 to fix
    build with GCC 6; patch
    upstream_webinterface-rename-major-minor-to-major_version-min.patch.
    (Closes: #811942)
  * Link in as-needed mode.
  * Remove manual CPPFLAGS handling, no more needed in debhelper compat 9.
  * Remove extra libsoprano-dev build dependency, which was added as workaround
    for a bug in kdelibs5-dev.
  * Replace kubuntu_magnet-mimetype.diff with part of the upstream commit
    f090d11e8837d944dedb40f873713abe4e15d4b4; patch
    upstream_Properly-support-x-scheme-handler-magnet-mimetype-an.patch.

 -- Pino Toscano <pino@debian.org>  Sun, 14 Feb 2016 17:34:29 +0100

ktorrent (4.3.1-3) unstable; urgency=medium

  * Team upload.

  [ Jonathan Riddell ]
  * Remove build-dep on kde-workspace, soon to be removed from the archive
  * Remove shutdown plugin from .install file which required kde-workspace
  * Add kubuntu_magnet-mimetype.diff to open magnet links
  * Remove obsolete build-dep on nepomuk-core-dev

  [ Scott Kitterman ]
  * Remove plasma-widget-ktorrent package as it is not compatible with
    Plasma 5
  * Remove obsolete ktorrent suggests
  * Remove ancient build-conflicts
  * Backport Ubuntu changes to Debian
  * Add build-depends on libsoprano-dev
  * Bump standards version to 3.9.6 without further change

 -- Scott Kitterman <scott@kitterman.com>  Mon, 31 Aug 2015 12:48:22 -0400

=== debian/control ===
Source: ktorrent
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Modestas Vainius <modax@debian.org>
Build-Depends: cmake (>= 2.8.12), debhelper (>= 9~), pkg-kde-tools (>= 0.15.16),
 extra-cmake-modules,
 qtbase5-dev (>= 5.7.0),
 qtscript5-dev (>= 5.7.0),
 libphonon4qt5-dev, libphonon4qt5experimental-dev,
 libkf5archive-dev (>= 5.15),
 libkf5completion-dev (>= 5.15),
 libkf5config-dev (>= 5.15),
 libkf5configwidgets-dev (>= 5.15),
 libkf5coreaddons-dev (>= 5.15),
 libkf5crash-dev (>= 5.15),
 libkf5dbusaddons-dev (>= 5.15),
 libkf5dnssd-dev (>= 5.15),
 libkf5doctools-dev (>= 5.15),
 libkf5i18n-dev (>= 5.15),
 libkf5iconthemes-dev (>= 5.15),
 libkf5kio-dev (>= 5.15),
 libkf5itemviews-dev (>= 5.15),
 libkf5notifications-dev (>= 5.15),
 libkf5notifyconfig-dev (>= 5.15),
 libkf5kcmutils-dev (>= 5.15),
 libkf5parts-dev (>= 5.15),
 libkf5plotting-dev (>= 5.15),
 libkf5service-dev (>= 5.15),
 libkf5solid-dev (>= 5.15),
 libkf5textwidgets-dev (>= 5.15),
 libkf5widgetsaddons-dev (>= 5.15),
 libkf5windowsystem-dev (>= 5.15),
 libkf5xmlgui-dev (>= 5.15),
 libkf5webkit-dev (>= 5.15),
 kross-dev (>= 5.15),
 libkf5syndication-dev,
 libboost-dev,
 libktorrent-dev (>= 2.1), libtag1-dev, libgeoip-dev,
Standards-Version: 4.1.0
Homepage: https://www.kde.org/applications/internet/ktorrent/
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-extras/ktorrent.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/ktorrent.git

Package: ktorrent
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ktorrent-data (= ${source:Version}),
 libktorrent-l10n
Suggests: krosspython, geoip-database
Description: BitTorrent client based on the KDE platform
 This package contains KTorrent, a BitTorrent peer-to-peer network client, that
 is based on the KDE platform. Obviously, KTorrent supports such basic features
 as downloading, uploading and seeding files on the BitTorrent network.
 However, lots of other additional features and intuitive GUI should make
 KTorrent a good choice for everyone. Some features are available as plugins
 hence you should make sure you have the ones you need enabled.
   - Support for HTTP and UDP trackers, trackerless DHT (mainline) and webseeds.
   - Alternative UI support including Web interface.
   - Torrent grouping, speed capping, various download prioritization
     capabilities on both torrent and file level as well as bandwidth
     scheduling.
   - Support for fetching torrent files from many sources including any local
     file or remote URL, RSS feeds (with filtering) or actively monitored
     directory etc.
   - Integrated and customizable torrent search on the Web.
   - Various security features like IP blocking and protocol encryption.
   - Disk space preallocation to reduce fragmentation.
   - uTorrent compatible peer exchange.
   - Autoconfiguration for LANs like Zeroconf extension and port forwarding via
     uPnP.
   - Scripting support via Kross and interprocess control via DBus interface.
   - SOCKSv4 and SOCKSv5 proxy, IPv6 support.
   - Lots of other useful built-in features and plugins.

Package: ktorrent-data
Architecture: all
Depends: ${misc:Depends}
Recommends: ktorrent (>= ${source:Version})
Description: KTorrent data and other architecture independent files
 This package contains architecture independent data files for KTorrent,
 a BitTorrent peer-to-peer network client. Unless you have ktorrent package
 installed, you probably won't find this package useful.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DWITH_SYSTEM_GEOIP:BOOL=ON \
	                           -DBUILD_TESTING=OFF

override_dh_install:
	dh_install --fail-missing

override_dh_strip:
	dh_strip --dbgsym-migration='ktorrent-dbg (<< 4.3.1-5~)'

%:
	dh $@ --parallel --with kf5

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4

http://download.kde.org/stable/ktorrent/([\d.]+)/ktorrent-([\d.]+)\.tar.xz

## ktorrent 5.1.1

=== ktorrent/CMakeLists.txt ===
#  set(kt4_SRC app.cpp mainwindow.cpp core.cpp view.cpp viewmodel.cpp main.cpp)
set(ktorrent_SRC 
	main.cpp
	core.cpp
	gui.cpp
	torrentactivity.cpp
	statusbar.cpp
	trayicon.cpp
	ipfilterlist.cpp
	ipfilterwidget.cpp
	
	tools/queuemanagerwidget.cpp
	tools/queuemanagermodel.cpp
	tools/magnetmodel.cpp
	tools/magnetview.cpp
	
	groups/grouppolicydlg.cpp
	groups/groupfiltermodel.cpp
	groups/groupview.cpp
	groups/groupviewmodel.cpp
	groups/groupswitcher.cpp
	
	dialogs/pastedialog.cpp
	dialogs/speedlimitsdlg.cpp
	dialogs/speedlimitsmodel.cpp
	dialogs/spinboxdelegate.cpp
	dialogs/torrentcreatordlg.cpp
	dialogs/missingfilesdlg.cpp
	dialogs/importdialog.cpp
	dialogs/addpeersdlg.cpp
	dialogs/fileselectdlg.cpp 
	
	pref/prefdialog.cpp 
	pref/advancedpref.cpp
	pref/networkpref.cpp
	pref/proxypref.cpp
	pref/qmpref.cpp
	pref/generalpref.cpp
	pref/recommendedsettingsdlg.cpp
	pref/btpref.cpp
	
	view/view.cpp 
	view/viewmodel.cpp
	view/viewdelegate.cpp
	view/viewselectionmodel.cpp
	view/viewjobtracker.cpp 
	view/scanextender.cpp
	view/propertiesdlg.cpp
	view/torrentsearchbar.cpp 
)


ki18n_wrap_ui(ktorrent_SRC
	ipfilterwidget.ui 
	
	dialogs/speedlimitsdlg.ui 
	dialogs/pastedlgbase.ui 
	dialogs/torrentcreatordlg.ui 
	dialogs/missingfilesdlg.ui
	dialogs/importdialog.ui
	dialogs/addpeersdlg.ui
	dialogs/fileselectdlg.ui 
	
	groups/grouppolicydlg.ui
	
	pref/qmpref.ui 
	pref/btpref.ui
	pref/generalpref.ui 
	pref/advancedpref.ui 
	pref/networkpref.ui
	pref/proxypref.ui
	pref/recommendedsettingsdlg.ui
	
	view/scanextender.ui
	view/propertiesdlg.ui
)

set(powermanagementinhibit_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.PowerManagement.Inhibit.xml)
qt5_add_dbus_interface(ktorrent_SRC ${powermanagementinhibit_xml} powermanagementinhibit_interface)

# collect icons
set(KTORRENT_ICONS_PNG
    icons/16-apps-ktorrent.png
    icons/22-apps-ktorrent.png
    icons/32-apps-ktorrent.png
    icons/48-apps-ktorrent.png
    icons/64-apps-ktorrent.png
    icons/128-apps-ktorrent.png
)

ecm_add_app_icon(ktorrent_SRC ICONS ${KTORRENT_ICONS_PNG})

add_executable(ktorrent_app ${ktorrent_SRC})
set_target_properties(ktorrent_app  PROPERTIES OUTPUT_NAME ktorrent)

target_link_libraries(ktorrent_app
    ktcore
    KF5::Torrent
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::DBusAddons
    KF5::I18n
    KF5::IconThemes
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::Notifications
    KF5::NotifyConfig
    KF5::Parts
    KF5::Solid
    KF5::WidgetsAddons
    KF5::WindowSystem
    KF5::XmlGui
)

install(TARGETS ktorrent_app ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.ktorrent.desktop  DESTINATION  ${XDG_APPS_INSTALL_DIR} )
install(FILES ktorrentui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )
install(FILES kttorrentactivityui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )
install(FILES ktorrent.notifyrc DESTINATION ${KNOTIFYRC_INSTALL_DIR} )
install(FILES org.kde.ktorrent.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

add_subdirectory(icons)

=== plasma/dataengine/CMakeLists.txt ===
set(ktengine_SRCS
    engine.cpp coredbusinterface.cpp torrentdbusinterface.cpp
)

add_library(plasma_engine_ktorrent MODULE ${ktengine_SRCS})
target_link_libraries(plasma_engine_ktorrent KF5::KDELibs4Support ${KDE4_PLASMA_LIBS} ${LIBKTORRENT_LIBRARIES})

install(TARGETS plasma_engine_ktorrent DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES plasma-dataengine-ktorrent.desktop DESTINATION ${SERVICES_INSTALL_DIR} )

=== plugins/shutdown/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
set(ktshutdownplugin_SRC shutdownruleset.cpp shutdowntorrentmodel.cpp shutdowndlg.cpp shutdownplugin.cpp)

set(screensaver_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.ScreenSaver.xml)
qt5_add_dbus_interface(ktshutdownplugin_SRC ${screensaver_xml} screensaver_interface)

set(powermanagement_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.PowerManagement.xml)
qt5_add_dbus_interface(ktshutdownplugin_SRC ${powermanagement_xml} powermanagement_interface)

ki18n_wrap_ui(ktshutdownplugin_SRC shutdowndlg.ui)

add_library(ktorrent_shutdown MODULE ${ktshutdownplugin_SRC})
kcoreaddons_desktop_to_json(ktorrent_shutdown ktorrent_shutdown.desktop)
target_link_libraries(
    ktorrent_shutdown
    ktcore
    KF5::Torrent
    PW::KWorkspace
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::I18n
    KF5::XmlGui
    KF5::WidgetsAddons
)

install(TARGETS ktorrent_shutdown  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_shutdownui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

=== plugins/syndication/CMakeLists.txt ===
set(ktsyndicationplugin_SRC 
	syndicationplugin.cpp 
	syndicationactivity.cpp
	syndicationtab.cpp
	feedlistview.cpp 
	feedlist.cpp 
	feedlistdelegate.cpp
	feedwidget.cpp 
	feedwidgetmodel.cpp
	feedretriever.cpp
	ktfeed.cpp
	linkdownloader.cpp
	managefiltersdlg.cpp
	filter.cpp
	filterlist.cpp
	filterlistview.cpp
	filterlistmodel.cpp
	filtereditor.cpp)

ki18n_wrap_ui(ktsyndicationplugin_SRC feedwidget.ui managefiltersdlg.ui filtereditor.ui)
add_library(ktorrent_syndication MODULE ${ktsyndicationplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_syndication ktorrent_syndication.desktop)

target_link_libraries(
    ktorrent_syndication
    ktcore
    KF5::Torrent
    KF5::CoreAddons
    KF5::ConfigCore
    KF5::I18n
    KF5::KIOCore
    KF5::KIOWidgets
    KF5::Syndication
    KF5::WebKit
    KF5::WidgetsAddons
    KF5::XmlGui
)
install(TARGETS ktorrent_syndication DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_syndicationui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

add_subdirectory(icons)

=== debian/changelog ===
ktorrent (5.1.1-1+rb2) UNRELEASED; urgency=medium

  * update

 -- Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>  Fri, 22 Jan 2021 11:44:40 +0800

ktorrent (5.1.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - fixes build with Qt >= 5.11 (Closes: #907328)
  * Update the patches:
    - upstream_QTimer-may-not-be-an-incomplete-type-as-it-is-used-a.patch:
      drop, backported from upstream
  * Remove the libkf5service-dev build dependency, no more needed.
  * Update Vcs-* fields.
  * Bump Standards-Version to 4.2.1, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 04 Sep 2018 07:31:46 +0200

ktorrent (5.1.0-3) unstable; urgency=medium

  * Team upload.
  * Backport the upstream commit 672c5076de7e3a526d9bdbb484a69e9386bc49f8 to
    include <QTimer> where needed; patch
    upstream_QTimer-may-not-be-an-incomplete-type-as-it-is-used-a.patch.
    (Closes: #897113)
  * Switch Vcs-* fields to salsa.debian.org.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Switch from dh_install to dh_missing for --fail-missing.
  * Remove trailing whitespaces in changelog.
  * Bump Standards-Version to 4.1.4, no changes required.
  * Switch watch file to https.

 -- Pino Toscano <pino@debian.org>  Sat, 28 Apr 2018 18:08:38 +0200

ktorrent (1.1-2.1) unstable; urgency=low

   * Non-maintainer upload by sponsor due to no maintainer reaction.
   * Relibtoolize _after_ setting AM_MAINTAINER_MODE (Closes: #349983)

 -- Florian Ernst <florian@debian.org>  Tue, 7 Feb 2006 13:15:30 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Modestas Vainius <modax@debian.org>
-Build-Depends: cmake (>= 2.8.12), debhelper (>= 9~), pkg-kde-tools (>= 0.15.16),
+Build-Depends: cmake (>= 2.8.12), debhelper (>= 11~), pkg-kde-tools (>= 0.15.16),
  extra-cmake-modules,
  qtbase5-dev (>= 5.7.0),
  qtscript5-dev (>= 5.7.0),
@@ -26,7 +26,6 @@
  libkf5kcmutils-dev (>= 5.15),
  libkf5parts-dev (>= 5.15),
  libkf5plotting-dev (>= 5.15),
- libkf5service-dev (>= 5.15),
  libkf5solid-dev (>= 5.15),
  libkf5textwidgets-dev (>= 5.15),
  libkf5widgetsaddons-dev (>= 5.15),
@@ -37,10 +36,10 @@
  libkf5syndication-dev,
  libboost-dev,
  libktorrent-dev (>= 2.1), libtag1-dev, libgeoip-dev,
-Standards-Version: 4.1.0
+Standards-Version: 4.2.1
 Homepage: https://www.kde.org/applications/internet/ktorrent/
-Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-extras/ktorrent.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/ktorrent.git
+Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/ktorrent.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/ktorrent
 
 Package: ktorrent
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DWITH_SYSTEM_GEOIP:BOOL=ON \
	                           -DBUILD_TESTING=OFF

override_dh_missing:
	dh_missing --fail-missing

override_dh_strip:
	dh_strip --dbgsym-migration='ktorrent-dbg (<< 4.3.1-5~)'

%:
	dh $@ --with kf5

.PHONY: override_dh_auto_test

## ktorrent 5.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(KTORRENT)

set (QT_MIN_VERSION "5.7.0")
set (KF5_MIN_VERSION "5.15")

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(GenerateExportHeader)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
    Core
    DBus
    Network
    Script
    Widgets
)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    I18n
    IconThemes
    KIO
    Notifications
    NotifyConfig
    KCMUtils
    Parts
    Solid
    WidgetsAddons
    WindowSystem
    XmlGui
)

find_package(KF5DocTools ${KF5_MIN_VERSION})

find_package(KF5Torrent 2.1 CONFIG REQUIRED)
find_package(Boost REQUIRED)

find_package(KF5TextWidgets ${KF5_REQUIRED_VERSION})
set_package_properties(KF5TextWidgets
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's IP Filter plugin"
)
if(KF5TextWidgets_FOUND)
  set(HAVE_KF5TextWidgets 1)
endif()

find_package(KF5Archive ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Archive
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's scripting plugin"
)
if(KF5Archive_FOUND)
  set(HAVE_KF5Archive 1)
endif()

find_package(KF5ItemViews ${KF5_REQUIRED_VERSION})
set_package_properties(KF5ItemViews
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's scripting plugin"
)
if(KF5ItemViews_FOUND)
  set(HAVE_KF5ItemViews 1)
endif()

find_package(KF5Kross ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Kross
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's scripting plugin"
)
if(KF5Kross_FOUND)
  set(HAVE_KF5Kross 1)
endif()

find_package(KF5Plotting ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Plotting
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's statistics plugin"
)
if(KF5Plotting_FOUND)
  set(HAVE_KF5Plotting 1)
endif()

find_package(KF5Syndication)
set_package_properties(KF5Syndication
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's syndication plugin"
)
if(KF5Syndication_FOUND)
  set(HAVE_KF5Syndication 1)
endif()

find_package(KF5WebKit ${KF5_REQUIRED_VERSION})
set_package_properties(KF5WebKit
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's search and syndication plugins"
)
if(KF5WebKit_FOUND)
  set(HAVE_KF5WebKit 1)
endif()

find_package(KF5DNSSD ${KF5_REQUIRED_VERSION})
set_package_properties(KF5DNSSD
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's Zeroconf plugin"
)
if(KF5DNSSD_FOUND)
  set(HAVE_KF5DNSSD 1)
endif()

find_package(KF5Completion ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Completion
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's UPnP plugin"
)
if(KF5Completion_FOUND)
  set(HAVE_KF5Completion 1)
endif()

find_package(LibKWorkspace CONFIG)
set_package_properties(LibKWorkspace
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's shutdown plugin"
)
if(LibKWorkspace_FOUND)
  set(HAVE_LibKWorkspace 1)
endif()

find_package(Taglib)
if(TAGLIB_FOUND)
  set(HAVE_Taglib 1)
endif()
#find_package(Qt5 ${QT_MIN_VERSION} OPTIONAL_COMPONENTS Multimedia MultimediaWidgets)
find_package(Phonon4Qt5)
set_package_properties(Taglib
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's multimedia plugin"
)
set_package_properties(Phonon4Qt5
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's multimedia plugin"
)

#
# checks for functions and stuff
#
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckTypeSize) #XFS


# according to http://www.cmake.org/pipermail/cmake/2008-June/022381.html
kde_enable_exceptions()

add_definitions(
  -DQT_USE_QSTRINGBUILDER
  -DQT_NO_CAST_TO_ASCII
  -DQT_NO_CAST_FROM_ASCII
  -DQT_STRICT_ITERATORS
  -DQT_NO_URL_CAST_FROM_STRING
  -DQT_NO_CAST_FROM_BYTEARRAY
  -DQT_NO_CAST_TO_BYTEARRAY
#   -DQT_NO_SIGNALS_SLOTS_KEYWORDS
  -DQT_USE_FAST_OPERATOR_PLUS
)

set (KTORRENT_DBUS_XML_DIR ${KTORRENT_SOURCE_DIR}/dbus_xml)
set (KTORRENT_PLUGIN_INSTALL_DIR ${PLUGIN_INSTALL_DIR}/ktorrent)

include_directories(
   ${Boost_INCLUDE_DIR}
)

add_subdirectory(libktcore)
add_subdirectory(plugins)
add_subdirectory(ktorrent)
add_subdirectory(ktupnptest)
#add_subdirectory(plasma)
add_subdirectory(ktmagnetdownloader)
if (KF5DocTools_FOUND)
    add_subdirectory(doc)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== ktorrent/CMakeLists.txt ===
--- 
+++ 
@@ -96,6 +96,7 @@
 target_link_libraries(ktorrent_app
     ktcore
     KF5::Torrent
+    KF5::Crash
     KF5::ConfigCore
     KF5::ConfigGui
     KF5::DBusAddons

=== ktorrent/icons/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,13 @@
 ecm_install_icons(ICONS
+    16-apps-ktorrent.png
+    22-apps-ktorrent.png
+    32-apps-ktorrent.png
+    48-apps-ktorrent.png
+    64-apps-ktorrent.png
+    128-apps-ktorrent.png
     16-actions-kt-stop-all.png
     16-actions-kt-stop.png
     16-actions-kt-upnp.png
-    16-apps-ktorrent.png
     22-actions-kt-magnet.png
     22-actions-kt-pause.png
     22-actions-kt-remove.png
@@ -13,7 +18,6 @@
     22-actions-kt-start.png
     22-actions-kt-stop-all.png
     22-actions-kt-stop.png
-    22-apps-ktorrent.png
     32-actions-kt-info-widget.png
     32-actions-kt-magnet.png
     32-actions-kt-pause.png
@@ -27,7 +31,6 @@
     32-actions-kt-stop-all.png
     32-actions-kt-stop.png
     32-actions-kt-upnp.png
-    32-apps-ktorrent.png
     48-actions-kt-bandwidth-scheduler.png
     48-actions-kt-change-tracker.png
     48-actions-kt-check-data.png
@@ -49,9 +52,7 @@
     48-actions-kt-stop-all.png
     48-actions-kt-stop.png
     48-actions-kt-upnp.png
-    48-apps-ktorrent.png
     64-actions-kt-magnet.png
-    64-apps-ktorrent.png
     sc-actions-kt-magnet.svgz
     sc-actions-kt-set-max-download-speed.svgz
     sc-actions-kt-set-max-upload-speed.svgz

=== plugins/ipfilter/tests/CMakeLists.txt ===
set(ipblocklisttest_SRCS ipblocklisttest.cpp ../ipblocklist.cpp)
add_executable(ipblocklisttest ${ipblocklisttest_SRCS})
add_test(ipblocklisttest ipblocklisttest)
ecm_mark_as_test(ipblocklisttest)
target_link_libraries(ipblocklisttest Qt5::Core Qt5::Network Qt5::Test ktcore)

=== debian/changelog ===
ktorrent (5.1.2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:17:37 +0100

ktorrent (5.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Remove unused plasma-widget-ktorrent.install file.
  * Drop the migration from ktorrent-dbg, no more needed after two Debian
    stable releases.
  * Bump the libktorrent-dev build dependency to 2.1.1, to make sure to build
    against the newer version.
  * Bump Standards-Version to 4.4.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 14 Sep 2019 14:56:28 +0200

=== debian/control ===
--- 
+++ 
@@ -35,8 +35,8 @@
  kross-dev (>= 5.15),
  libkf5syndication-dev,
  libboost-dev,
- libktorrent-dev (>= 2.1), libtag1-dev, libgeoip-dev,
-Standards-Version: 4.2.1
+ libktorrent-dev (>= 2.1.1~), libtag1-dev, libgeoip-dev,
+Standards-Version: 4.4.0
 Homepage: https://www.kde.org/applications/internet/ktorrent/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/ktorrent.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/ktorrent

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,6 @@
 override_dh_missing:
 	dh_missing --fail-missing
 
-override_dh_strip:
-	dh_strip --dbgsym-migration='ktorrent-dbg (<< 4.3.1-5~)'
-
 %:
 	dh $@ --with kf5

=== debian/watch ===
version=4

https://download.kde.org/stable/ktorrent/([\d.]+)/ktorrent-([\d.]+)\.tar.xz
